<?php
class blognetworking_actions extends wv46v_action {
	public function blognetworking_syncWPactionMeta($return)
	{
		$return['schedule'] = $this->data()->network['schedule'];
		return $return;
	}
	public function blognetworking_syncWPaction()
	{
		$network = $this->data()->network;
		$links = $this->get_links ( $network ['url'] );
		$blogs = $this->get_blogs ( $links );
		$this->data('posts')->posts = $this->select_order ( $blogs, $this->data()->network );
	}
	private $in_write=false;
	public function blognetworking_write_networkWPfilter($data) {
		if ($data ['url']!='' && !$this->in_write) {
			$this->in_write=true;
			do_action('blognetworking_sync');
			$this->in_write=false;
		}
		return $data;
	}	
	private function get_blogs($links) {
		$blog = array ();
		foreach ( $links as $link ) {
			if ($link ['xml_url'] != '') {
				$feed = fetch_feed ($link['xml_url']);
				if(!is_wp_error($feed))
				{
					$newblog = array ();
					$newblog['title']=$feed->get_title();
					$newblog['favicon']=$feed->get_favicon();
					$newblog['link']=$feed->get_permalink();
					$newblog['description']=$feed->get_description();
						$newblog ['items'] = array ();
					foreach($feed->get_items() as $item)
					{
						$newitem = array ();
						$newitem ['title'] = $item->get_title();
						$newitem ['link'] = $item->get_permalink();
						$newitem ['pubdate'] = $item->get_date();
						$newitem ['author'] = $item->get_author()->name;
						$newblog ['items'] [] = $newitem;
					}
					$blog [$newblog['link']] = $newblog;
				}
			}
		}
		return $blog;
	}
	private function get_links($blogroll) {
		$f = new wv46v_opml (  );
		$OPML = $f->get ($blogroll);
		$fixed = array ();
		foreach ( $OPML as $okey => $o ) {
			foreach ( ( array ) $o as $v ) {
				if (isset ( $v ['tag'] ) && $v ['tag'] == 'BODY') {
					foreach ( ( array ) $v as $v2 ) {
						if (isset ( $v2 ['tag'] ) && $v2 ['tag'] == 'OUTLINE') {
							$cat = $v2 ['attributes'] ['TITLE'];
							foreach ( ( array ) $v2 as $v3 ) {
								if (isset ( $v3 ['tag'] ) && $v3 ['tag'] == 'OUTLINE' && $v3 ['attributes'] ['TYPE'] == 'link') {
									$fixed_new = array ();
									$fixed_new ['title'] = $v3 ['attributes'] ['TEXT'];
									$fixed_new ['html_url'] = $v3 ['attributes'] ['HTMLURL'];
									$fixed_new ['xml_url'] = $v3 ['attributes'] ['XMLURL'];
									$fixed_new ['categories'] = $cat;
									if (array_key_exists ( $fixed_new ['title'], $fixed )) {
										$fixed [$fixed_new ['title']] ['categories'] .= ',' . $fixed_new ['categories'];
									} else {
										$fixed [$fixed_new ['title']] = $fixed_new;
									}
								}
							}
						}
					}
				}
			}
		}
		return $fixed;
	}
	public function select_order($blogs, $settings) {
		$posts = array ();
		foreach ( $blogs as $blog ) {
			$blog_det = $blog;
			unset ( $blog_det ['items'] );
			$cnt = 0;
			foreach ( $blog ['items'] as $item ) {
				$post = $item;
				$post ['blog'] = $blog_det;
				$posts [] = $post;
				$cnt ++;
				if ($cnt == $settings ['site_max']) {
					break;
				}
			}
		}
		usort ( $posts, array ($this, 'single_sort' ) );
		$newposts = array ();
		$cnt = 0;
		foreach ( $posts as $post ) {
			$cnt ++;
			$newposts [] = $post;
			if ($cnt == $settings ['net_max']) {
				break;
			}
		}
		$posts = $newposts;
		$newposts = null;
		return $posts;
	}
	public function single_sort($a, $b) {
		if (strtotime ( $a ['pubdate'] ) == strtotime ( $b ['pubdate'] )) {
			return 0;
		}
		return (strtotime ( $a ['pubdate'] ) > strtotime ( $b ['pubdate'] )) ? - 1 : 1;
	}
	public function initWPaction() {
		add_action ( 'showNetwork', array ($this, 'showNetwork' ) );
		blognetworking_widget::$application = $this->application ();
		register_widget ( 'blognetworking_widget' );
	}
	public function showNetwork($title = '') {
		if ($title == '') {
			$title = "Recent Community Posts";
		}
		$this->view->data = $this->data ( 'posts' )->posts;
		$this->view->title = $title;
		$this->view->_e ( $this->render_script ( 'front/widget.phtml' ) );
	}
}